"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from exfunc.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class TotalRoundsTypedDict(TypedDict):
    r"""Total rounds of funding information"""


class TotalRounds(BaseModel):
    r"""Total rounds of funding information"""


class LastRoundTypedDict(TypedDict):
    r"""Last round of funding information"""


class LastRound(BaseModel):
    r"""Last round of funding information"""


class InvestorsTypedDict(TypedDict):
    pass


class Investors(BaseModel):
    pass


class FundingTypedDict(TypedDict):
    r"""Funding information for the company"""

    total_rounds: NotRequired[TotalRoundsTypedDict]
    r"""Total rounds of funding information"""
    last_round: NotRequired[LastRoundTypedDict]
    r"""Last round of funding information"""
    investors: NotRequired[List[InvestorsTypedDict]]
    r"""List of investors"""


class Funding(BaseModel):
    r"""Funding information for the company"""

    total_rounds: Optional[TotalRounds] = None
    r"""Total rounds of funding information"""

    last_round: Optional[LastRound] = None
    r"""Last round of funding information"""

    investors: Optional[List[Investors]] = None
    r"""List of investors"""


class LinkedInCompanyTypedDict(TypedDict):
    url: NotRequired[str]
    r"""URL to the company's profile"""
    name: NotRequired[str]
    r"""Name of the company"""
    location: NotRequired[str]
    r"""Location of the company"""
    industry: NotRequired[str]
    r"""Industry in which the company operates"""
    overview: NotRequired[str]
    r"""Overview or description of the company"""
    size: NotRequired[str]
    r"""Size of the company (e.g., number of employees)"""
    specialties: NotRequired[str]
    r"""Commma separated string of specialties or areas of expertise for the company"""
    website_url: NotRequired[str]
    r"""Company's website URL"""
    funding: NotRequired[FundingTypedDict]
    r"""Funding information for the company"""


class LinkedInCompany(BaseModel):
    url: Optional[str] = None
    r"""URL to the company's profile"""

    name: Optional[str] = None
    r"""Name of the company"""

    location: Optional[str] = None
    r"""Location of the company"""

    industry: Optional[str] = None
    r"""Industry in which the company operates"""

    overview: Optional[str] = None
    r"""Overview or description of the company"""

    size: Optional[str] = None
    r"""Size of the company (e.g., number of employees)"""

    specialties: Optional[str] = None
    r"""Commma separated string of specialties or areas of expertise for the company"""

    website_url: Optional[str] = None
    r"""Company's website URL"""

    funding: Optional[Funding] = None
    r"""Funding information for the company"""
